#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QtSql/QSqlDatabase>
#include <QSqlQueryModel>
#include <QSqlQuery>
#include <QSqlRecord>
#include <QStringListModel>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    QSqlDatabase db = QSqlDatabase::addDatabase( "QSQLITE" );
    db.setDatabaseName(":memory:");
    db.open();

    db.exec( "CREATE TABLE test (id INTEGER PRIMARY KEY, text TEXT)" );
    db.exec( "INSERT INTO test VALUES (NULL, 'one'), (NULL, 'two'), (NULL, 'three')" );

    this->mdl = new QSqlQueryModel( this );
    this->mdl->setQuery( "SELECT * FROM test" );

    this->ui->sourceView->setModel( this->mdl );

    this->tgtMdl = new QStringListModel( this );
    this->ui->targetView->setModel( this->tgtMdl );

    connect( this->ui->sourceView, &QTableView::doubleClicked,
             this, &MainWindow::copyRow );
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::copyRow(QModelIndex idx)
{
    if( !idx.isValid() ) return;

    QStringList strings = this->tgtMdl->stringList();

    QSqlRecord rec = this->mdl->record( idx.row() );
    strings.append( QString( "%1, %2" ).arg( rec.value("id").toString() )
                                       .arg( rec.value("text").toString() ) );
    this->tgtMdl->setStringList( strings );
}
